/*
  File autogenerated by gengetopt version 2.19
  generated with the following command:
  gengetopt --input=xyz_iv_cmd.ggo --file-name=xyz_iv_cmd --unamed-opts 

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "getopt.h"

#include "xyz_iv_cmd.h"

const char *gengetopt_args_info_purpose = "Convert xyz points to OpenInventor Models";

const char *gengetopt_args_info_usage = "Usage: xyz_iv [OPTIONS]... [FILES]...";

const char *gengetopt_args_info_description = "";

const char *gengetopt_args_info_help[] = {
  "  -h, --help             Print help and exit",
  "  -V, --version          Print version and exit",
  "  -v, --verbosity=INT    Set the verbosity level (0=quiet 10=verbose \n                           20=bombastic)  (default=`0')",
  "  -o, --out=filename     Ouput the OpenInventor model here",
  "  -b, --box[=width]      Draw a box around each point  (default=`0.1')",
  "  -c, --color=r g b      Select the color with each channel [0..1].  Make sure \n                           to put quotes around your r g b's ",
  "  -l, --linked           Draw lines between each of the points",
  "  -p, --polarlines       Draw lines from the origin to each point  \n                           (default=off)",
  "  -s, --sphere[=radius]  Draw a sphere around each point  (default=`0.1')",
    0
};

static
void clear_given (struct gengetopt_args_info *args_info);
static
void clear_args (struct gengetopt_args_info *args_info);

static int
cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error);

static int
cmdline_parser_required2 (struct gengetopt_args_info *args_info, const char *prog_name, const char *additional_error);

static char *
gengetopt_strdup (const char *s);

static
void clear_given (struct gengetopt_args_info *args_info)
{
  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->verbosity_given = 0 ;
  args_info->out_given = 0 ;
  args_info->box_given = 0 ;
  args_info->color_given = 0 ;
  args_info->linked_given = 0 ;
  args_info->polarlines_given = 0 ;
  args_info->sphere_given = 0 ;
}

static
void clear_args (struct gengetopt_args_info *args_info)
{
  args_info->verbosity_arg = 0;
  args_info->verbosity_orig = NULL;
  args_info->out_arg = NULL;
  args_info->out_orig = NULL;
  args_info->box_arg = 0.1;
  args_info->box_orig = NULL;
  args_info->color_arg = NULL;
  args_info->color_orig = NULL;
  args_info->polarlines_flag = 0;
  args_info->sphere_arg = 0.1;
  args_info->sphere_orig = NULL;
  
}

static
void init_args_info(struct gengetopt_args_info *args_info)
{
  args_info->help_help = gengetopt_args_info_help[0] ;
  args_info->version_help = gengetopt_args_info_help[1] ;
  args_info->verbosity_help = gengetopt_args_info_help[2] ;
  args_info->out_help = gengetopt_args_info_help[3] ;
  args_info->box_help = gengetopt_args_info_help[4] ;
  args_info->color_help = gengetopt_args_info_help[5] ;
  args_info->linked_help = gengetopt_args_info_help[6] ;
  args_info->polarlines_help = gengetopt_args_info_help[7] ;
  args_info->sphere_help = gengetopt_args_info_help[8] ;
  
}

void
cmdline_parser_print_version (void)
{
  printf ("%s %s\n", CMDLINE_PARSER_PACKAGE, CMDLINE_PARSER_VERSION);
}

void
cmdline_parser_print_help (void)
{
  int i = 0;
  cmdline_parser_print_version ();

  if (strlen(gengetopt_args_info_purpose) > 0)
    printf("\n%s\n", gengetopt_args_info_purpose);

  printf("\n%s\n\n", gengetopt_args_info_usage);

  if (strlen(gengetopt_args_info_description) > 0)
    printf("%s\n", gengetopt_args_info_description);

  while (gengetopt_args_info_help[i])
    printf("%s\n", gengetopt_args_info_help[i++]);
}

void
cmdline_parser_init (struct gengetopt_args_info *args_info)
{
  clear_given (args_info);
  clear_args (args_info);
  init_args_info (args_info);

  args_info->inputs = NULL;
  args_info->inputs_num = 0;
}

static void
cmdline_parser_release (struct gengetopt_args_info *args_info)
{
  
  unsigned int i;
  if (args_info->verbosity_orig)
    {
      free (args_info->verbosity_orig); /* free previous argument */
      args_info->verbosity_orig = 0;
    }
  if (args_info->out_arg)
    {
      free (args_info->out_arg); /* free previous argument */
      args_info->out_arg = 0;
    }
  if (args_info->out_orig)
    {
      free (args_info->out_orig); /* free previous argument */
      args_info->out_orig = 0;
    }
  if (args_info->box_orig)
    {
      free (args_info->box_orig); /* free previous argument */
      args_info->box_orig = 0;
    }
  if (args_info->color_arg)
    {
      free (args_info->color_arg); /* free previous argument */
      args_info->color_arg = 0;
    }
  if (args_info->color_orig)
    {
      free (args_info->color_orig); /* free previous argument */
      args_info->color_orig = 0;
    }
  if (args_info->sphere_orig)
    {
      free (args_info->sphere_orig); /* free previous argument */
      args_info->sphere_orig = 0;
    }
  
  for (i = 0; i < args_info->inputs_num; ++i)
    free (args_info->inputs [i]);
  
  if (args_info->inputs_num)
    free (args_info->inputs);
  
  clear_given (args_info);
}

int
cmdline_parser_file_save(const char *filename, struct gengetopt_args_info *args_info)
{
  FILE *outfile;
  int i = 0;

  outfile = fopen(filename, "w");

  if (!outfile)
    {
      fprintf (stderr, "%s: cannot open file for writing: %s\n", CMDLINE_PARSER_PACKAGE, filename);
      return EXIT_FAILURE;
    }

  if (args_info->help_given) {
    fprintf(outfile, "%s\n", "help");
  }
  if (args_info->version_given) {
    fprintf(outfile, "%s\n", "version");
  }
  if (args_info->verbosity_given) {
    if (args_info->verbosity_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "verbosity", args_info->verbosity_orig);
    } else {
      fprintf(outfile, "%s\n", "verbosity");
    }
  }
  if (args_info->out_given) {
    if (args_info->out_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "out", args_info->out_orig);
    } else {
      fprintf(outfile, "%s\n", "out");
    }
  }
  if (args_info->box_given) {
    if (args_info->box_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "box", args_info->box_orig);
    } else {
      fprintf(outfile, "%s\n", "box");
    }
  }
  if (args_info->color_given) {
    if (args_info->color_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "color", args_info->color_orig);
    } else {
      fprintf(outfile, "%s\n", "color");
    }
  }
  if (args_info->linked_given) {
    fprintf(outfile, "%s\n", "linked");
  }
  if (args_info->polarlines_given) {
    fprintf(outfile, "%s\n", "polarlines");
  }
  if (args_info->sphere_given) {
    if (args_info->sphere_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "sphere", args_info->sphere_orig);
    } else {
      fprintf(outfile, "%s\n", "sphere");
    }
  }
  
  fclose (outfile);

  i = EXIT_SUCCESS;
  return i;
}

void
cmdline_parser_free (struct gengetopt_args_info *args_info)
{
  cmdline_parser_release (args_info);
}


/* gengetopt_strdup() */
/* strdup.c replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = NULL;
  if (!s)
    return result;

  result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

int
cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info)
{
  return cmdline_parser2 (argc, argv, args_info, 0, 1, 1);
}

int
cmdline_parser2 (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required)
{
  int result;

  result = cmdline_parser_internal (argc, argv, args_info, override, initialize, check_required, NULL);

  if (result == EXIT_FAILURE)
    {
      cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
cmdline_parser_required (struct gengetopt_args_info *args_info, const char *prog_name)
{
  int result = EXIT_SUCCESS;

  if (cmdline_parser_required2(args_info, prog_name, NULL) > 0)
    result = EXIT_FAILURE;

  if (result == EXIT_FAILURE)
    {
      cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
cmdline_parser_required2 (struct gengetopt_args_info *args_info, const char *prog_name, const char *additional_error)
{
  int error = 0;

  /* checks for required options */
  if (! args_info->out_given)
    {
      fprintf (stderr, "%s: '--out' ('-o') option required%s\n", prog_name, (additional_error ? additional_error : ""));
      error = 1;
    }
  
  
  /* checks for dependences among options */

  return error;
}

int
cmdline_parser_internal (int argc, char * const *argv, struct gengetopt_args_info *args_info, int override, int initialize, int check_required, const char *additional_error)
{
  int c;	/* Character of the parsed option.  */

  int error = 0;
  struct gengetopt_args_info local_args_info;

  if (initialize)
    cmdline_parser_init (args_info);

  cmdline_parser_init (&local_args_info);

  optarg = 0;
  optind = 0;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      char *stop_char;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "verbosity",	1, NULL, 'v' },
        { "out",	1, NULL, 'o' },
        { "box",	2, NULL, 'b' },
        { "color",	1, NULL, 'c' },
        { "linked",	0, NULL, 'l' },
        { "polarlines",	0, NULL, 'p' },
        { "sphere",	2, NULL, 's' },
        { NULL,	0, NULL, 0 }
      };

      stop_char = 0;
      c = getopt_long (argc, argv, "hVv:o:b::c:lps::", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          cmdline_parser_print_help ();
          cmdline_parser_free (&local_args_info);
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
          cmdline_parser_print_version ();
          cmdline_parser_free (&local_args_info);
          exit (EXIT_SUCCESS);

        case 'v':	/* Set the verbosity level (0=quiet 10=verbose 20=bombastic).  */
          if (local_args_info.verbosity_given)
            {
              fprintf (stderr, "%s: `--verbosity' (`-v') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->verbosity_given && ! override)
            continue;
          local_args_info.verbosity_given = 1;
          args_info->verbosity_given = 1;
          args_info->verbosity_arg = strtol (optarg, &stop_char, 0);
          if (!(stop_char && *stop_char == '\0')) {
            fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
            goto failure;
          }
          if (args_info->verbosity_orig)
            free (args_info->verbosity_orig); /* free previous string */
          args_info->verbosity_orig = gengetopt_strdup (optarg);
          break;

        case 'o':	/* Ouput the OpenInventor model here.  */
          if (local_args_info.out_given)
            {
              fprintf (stderr, "%s: `--out' (`-o') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->out_given && ! override)
            continue;
          local_args_info.out_given = 1;
          args_info->out_given = 1;
          if (args_info->out_arg)
            free (args_info->out_arg); /* free previous string */
          args_info->out_arg = gengetopt_strdup (optarg);
          if (args_info->out_orig)
            free (args_info->out_orig); /* free previous string */
          args_info->out_orig = gengetopt_strdup (optarg);
          break;

        case 'b':	/* Draw a box around each point.  */
          if (local_args_info.box_given)
            {
              fprintf (stderr, "%s: `--box' (`-b') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->box_given && ! override)
            continue;
          local_args_info.box_given = 1;
          args_info->box_given = 1;
          if (optarg)
            {
              args_info->box_arg = (float)strtod (optarg, &stop_char);
              if (!(stop_char && *stop_char == '\0')) {
                fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
                goto failure;
              }
              if (args_info->box_orig)
                free (args_info->box_orig); /* free previous string */
              args_info->box_orig = gengetopt_strdup (optarg);
            }
          break;

        case 'c':	/* Select the color with each channel [0..1].  Make sure to put quotes around your r g b's .  */
          if (local_args_info.color_given)
            {
              fprintf (stderr, "%s: `--color' (`-c') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->color_given && ! override)
            continue;
          local_args_info.color_given = 1;
          args_info->color_given = 1;
          if (args_info->color_arg)
            free (args_info->color_arg); /* free previous string */
          args_info->color_arg = gengetopt_strdup (optarg);
          if (args_info->color_orig)
            free (args_info->color_orig); /* free previous string */
          args_info->color_orig = gengetopt_strdup (optarg);
          break;

        case 'l':	/* Draw lines between each of the points.  */
          if (local_args_info.linked_given)
            {
              fprintf (stderr, "%s: `--linked' (`-l') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->linked_given && ! override)
            continue;
          local_args_info.linked_given = 1;
          args_info->linked_given = 1;
          break;

        case 'p':	/* Draw lines from the origin to each point.  */
          if (local_args_info.polarlines_given)
            {
              fprintf (stderr, "%s: `--polarlines' (`-p') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->polarlines_given && ! override)
            continue;
          local_args_info.polarlines_given = 1;
          args_info->polarlines_given = 1;
          args_info->polarlines_flag = !(args_info->polarlines_flag);
          break;

        case 's':	/* Draw a sphere around each point.  */
          if (local_args_info.sphere_given)
            {
              fprintf (stderr, "%s: `--sphere' (`-s') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->sphere_given && ! override)
            continue;
          local_args_info.sphere_given = 1;
          args_info->sphere_given = 1;
          if (optarg)
            {
              args_info->sphere_arg = (float)strtod (optarg, &stop_char);
              if (!(stop_char && *stop_char == '\0')) {
                fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
                goto failure;
              }
              if (args_info->sphere_orig)
                free (args_info->sphere_orig); /* free previous string */
              args_info->sphere_orig = gengetopt_strdup (optarg);
            }
          break;


        case 0:	/* Long option with no short option */
        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          goto failure;

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c%s\n", CMDLINE_PARSER_PACKAGE, c, (additional_error ? additional_error : ""));
          abort ();
        } /* switch */
    } /* while */



  if (check_required)
    {
      error += cmdline_parser_required2 (args_info, argv[0], additional_error);
    }

  cmdline_parser_release (&local_args_info);

  if ( error )
    return (EXIT_FAILURE);

  if (optind < argc)
    {
      int i = 0 ;
      int found_prog_name = 0;
      /* whether program name, i.e., argv[0], is in the remaining args
         (this may happen with some implementations of getopt,
          but surely not with the one included by gengetopt) */

      i = optind;
      while (i < argc)
        if (argv[i++] == argv[0]) {
          found_prog_name = 1;
          break;
        }
      i = 0;

      args_info->inputs_num = argc - optind - found_prog_name;
      args_info->inputs =
        (char **)(malloc ((args_info->inputs_num)*sizeof(char *))) ;
      while (optind < argc)
        if (argv[optind++] != argv[0])
          args_info->inputs[ i++ ] = gengetopt_strdup (argv[optind-1]) ;
    }

  return 0;

failure:
  
  cmdline_parser_release (&local_args_info);
  return (EXIT_FAILURE);
}
